#!/usr/bin/perl -w
$| = 1;

################################################
# Version 2.3.0                      Oct 03    #
#                                              #
# Webmail utility to check mail using regular  #
# Pop mail, sends via SMTP.                    #
#                                              #
# by Jason Woodward <woodwardj@jaos.org>       #
################################################

### initialize the vars
$LOGOUTURL = '';
$successauth = '';
$SEMISPOTLESS = 1;
$CONCISELISTING = 1;
$SHOW_HEADER = 0;
$USE_COOKIES = 0;
$POPSERVER = '';
$LISTMESSAGES_DELETE = '';
$LISTMESSAGES_CONNECTION_FAILED = '';
$LISTMESSAGES_ON = '';
$CREATEMESSAGE_SEND = '';
$DELETEMESSAGE_ALL_MESSAGE_QUESTION = '';
$LISTMESSAGES_SIZE = '';
$REPLYMESSAGE_YOU_WROTE = '';
$DELETEMESSAGE_ALL_WARNING = '';
#$LISTMESSAGES_MESSAGE = '';
$LISTMESSAGES_DELETE_MESSAGE = '';
$READMESSAGE_REPLY = '';
$DELETEMESSAGE_ALL_MESSAGE = '';
$LOGIN_TITLE_LOGIN = '';
$DELETEMESSAGE_ALL_CANCEL = '';
$ERRNO_MESSAGE = '';
$SENDMESSAGE_NOT_OPEN = '';
$W_WROTE = '';
$LISTMESSAGES_CURRENT = '';
$LISTMESSAGES_NOSUBJECT = '';
$W_DATE = '';
$LOGIN = '';
$W_REPLY_TO = 'Reply To';
$MAXMESSLISTNUM = 50;
$BGCOLOR = "#5a7d9b";

### Load configuration file and language pack
require "./webmail.conf";
require "./language.eng";

### Set $successauth to whatever output you get from your
### POP3 server upon successful login... such as if you 
### telneted into localhost 110 and gave a valid username
### and password... 
$successauth = 'OK Mailbox open';

### Set $debug if you want to see some additional info on boundry names
### and junk like that. - shead
$debug = 0;

### Set $datelanguage to something else but remember to add
### appropriate code to the get_date function. - shead
$datelanguage = 'english';

### Set $vhost_support to 1 for translating user@other.domain to
### pop-account@this.host. **-- not even attempted yet.
### This will need some sort of vhost -> pop account mapping so I've
### not even tried looking at it yet.  - shead
$vhost_support = 0;

### Ok, there was a problem with the Blowfish module and it only supporting
### 8 character passwords.  per the author of the blowfish module, we are
### going to use the Crypt::CBC module (along with the blowfish module)
### so that we can encrypt long strings.
$use_encryption = 1;

### Set $encrypt_key to 16 or more letters/numbers of fairly random
### printable stuff (only the first 16 chars are used).
### You can change this anytime you like but existing user sessions will
### break I think. - shead
$encrypt_key = 'ThssJstnthrBmbTrck';

##############end configure#####################
#$query = new CGI;
use CGI qw(:standard);
use Mail::POP3Client;
use Socket;
use MIME::Base64;

# this BEGIN block is to trap the error if Net::SMTP is not found
# it needs to be BEGIN because use happens at compile time, but
# eval happens at run time (BEGIN is in run time at compile time)
BEGIN {
        eval 'use Net::SMTP;';
        if ($@){
                warn "The Net::SMTP module is not installed. You can install it from CPAN.\n";
                $usesmtp=0;
        } else {
                $usesmtp=1;
        }
} # end begin

# point &sendmessage to the appropriate subroutine
# (yeah, this is a bit of a kludge, but the subroutines
# are not available at compile time, when the begin runs--kkeller)
if ($usesmtp){
        *sendmessage=\&sendsmtp;
}

if($use_encryption){
	use Crypt::Blowfish;
	use Crypt::CBC;
	$cipher_handle = new Crypt::CBC($encrypt_key,'Blowfish');
}


my $attachment = param("attachment");
my $action = param("action");
my $messnum = param("messnum");
my @delmessnum = param("delmessnum");
my $to = param("to");
my $from = param("from");
my $subject = param("subject");
my $replyto = param("replyto");
my $mbody = param("mbody");
my $bcc = param("bcc");
my $cc = param("cc");
my $file_name = param("filename");
my $lastdisplayed = param("lastdisplayed");
my $encrypted_pass = '';
my $username;
my $password;

### Check to see if there is a cookie set for the username and password
### If not, we will set one after initial login
unless($USE_COOKIES) {
	$username = param("username");
	$password = param("password");
} else {
	chomp($WEBSERVER);
	if(&cookie( -name => "$WEBSERVER" )){
		($username, $password) = split / /,&cookie( -name => "$WEBSERVER");
	} else {
		$username = param("username");
		$password = param("password");
	}
}
#chomp($username, $password);

### check the username and password
if (!$username || !$password || $username eq "" && $password eq "") {
   &login();
   exit 0;
} elsif ($username eq '' || $password eq '') {
   &login();
   exit 0;
}

### now we find out if the pass is encrypted
if ($use_encryption) {
	if($password =~ /^WebMailEncrypt:(.*)/){
		$encrypted_pass = $1;
		$password = &decrypt_pass($encrypted_pass);
		$encrypted_pass = 'WebMailEncrypt:' . $encrypted_pass;
	} else { # this will be the first submit only
		$encrypted_pass = 'WebMailEncrypt:' .  &encrypt_pass($password);
	}
} else {
	$encrypted_pass = $password;
}
if($username){
	$username =~ s/\@.*//g unless $vhost_support;
}

### open a connection for the functions to use
$pop = new Mail::POP3Client( $username, $password, $POPSERVER );
   my $servermessage = $pop->Message;
   unless($servermessage =~ /^\+OK/){
      if ($servermessage =~ m/ERR(.*)/) {
         &errno(":::: $1");
      }else{
         &errno($LISTMESSAGES_CONNECTION_FAILED);
      }
   }

### lets clean up the attachment if its defined...
### IE sends the full path
#if($attachment){
	#$attachment =~ s/( )(%)(\:)/_/g;
	#$attachment =~ s/^[-.]+//;
	#if($attachment =~ /\\/){
		#my @filename_parts = split /\\/,$attachment;
		#my $length = scalar(@filename_parts);
		#$attachment = $filename_parts[--$length];
	#}
#}

### find out what to do
if ($action eq "logout") {
   print "Location: $LOGOUTURL\n\n";
   exit 0;
} elsif ($action eq "login") {
   &login();
} elsif ($action eq "listmessages") {
   &listmessages(\$pop,\$username,\$encrypted_pass,$lastdisplayed);
} elsif ($action eq "readmessage") {
   &readmessage(\$pop,\$username,\$encrypted_pass,\$messnum);
} elsif ($action eq "createmessage") {
   &createmessage(\$username,\$encrypted_pass,$to);
} elsif ($action eq "replymessage") {
   &replymessage(\$pop,\$to,\$subject,\$messnum,\$username,\$encrypted_pass);
} elsif ($action eq "deletemessage") {
   if($delmessnum[0]){
   	foreach(@delmessnum){
  		&deletemessage(\$pop,$_);
	}
   }else{
  	 &deletemessage(\$pop,$messnum);
   }
	### b/c the message deletion isnt final until the connection
	### closes, we will close and reopen a connection here to 
	### prevent a ghost entry in the message list
	###
	$pop->Close();
	###
	$pop = new Mail::POP3Client( $username, $password, $POPSERVER );
	my $servermessage = $pop->Message;
	unless($servermessage =~ /^\+OK/){
		if ($servermessage =~ m/ERR(.*)/) {
			&errno(":::: $1");
		}else{
			&errno($LISTMESSAGES_CONNECTION_FAILED);
		}
	}
	###
   &listmessages(\$pop,\$username,\$encrypted_pass);
} elsif ($action eq "deleteallconfirm") {
   &deleteallconfirm(\$username,\$encrypted_pass);
} elsif ($action eq "deleteall") {
   &deleteall(\$pop);
   &listmessages(\$pop,\$username,\$encrypted_pass);
} elsif ($action eq "sendmessage") {
   &sendmessage(\$username,\$to,\$mbody,\$replyto,\$subject,\$attachment,\$cc,\$bcc);
   &listmessages(\$pop,\$username,\$encrypted_pass);
} elsif ($action eq "forwardmessage") {
   &forwardmessage(\$pop,\$username,\$encrypted_pass,\$subject,\$replyto,\$from);
} elsif ($action eq "getattachment") {
   &getattachment(\$pop);
}elsif ($action eq "") {
   &login();
} else { 
   &errno("ERROR!! NOTHING TO DO");
}
### close any open connections
if($pop){$pop->Close();}
1;

sub login {
   &print_header();
   print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0" BGCOLOR="$BGCOLOR">
<TR>
   <TD>
   <FONT COLOR="#FFFFFF" SIZE="4"><B>$HOSTNAME - $LOGIN_TITLE_LOGIN</B></FONT>
   </TD>
</TR>
</TABLE>
<BR><BR>
<FORM ACTION="$CGIBINLOCATION" METHOD=post>
<INPUT TYPE="hidden" NAME="action" VALUE="listmessages">
<B>$LOGIN_USERNAME</B><BR><INPUT TYPE="text" NAME="username"><BR>
<B>$LOGIN_PASSWORD</B><BR><INPUT TYPE="password" NAME="password"><BR>
<INPUT TYPE="submit" VALUE="$LOGIN">
</FORM>
!;
   &print_footer();
}

sub createmessage {
	my ($username,$encrypted_pass,$to) = @_;
   &print_header();
        &print_lefttoolbar();
        print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0"
BGCOLOR="$BGCOLOR">
<TR>
   <TD>
   <FONT COLOR="#FFFFFF" SIZE="4"><B>$CREATEMESSAGE_SEND</a></B></FONT>
   </TD>
</TR>
<FORM ACTION="$CGIBINLOCATION" METHOD="POST" ENCTYPE="multipart/form-data">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
        }
print STDOUT qq!
<TR>
   <TD valign=top align=left></TD>
   <TD valign=top align=left>
   <FONT COLOR="#FFFFFF" size=2 face="Arial">recipients seperated by (; or ,)</FONT>
   </TD>
</TR>
<INPUT TYPE="hidden" NAME="action" VALUE="sendmessage">
<TR>
   <TD>$W_TO: </TD>
   <TD><INPUT TYPE="text" NAME="to" SIZE="50" value="$to"></TD>
</TR>
<TR>
   <TD>$W_CC: </TD>
   <TD><INPUT TYPE="text" NAME="cc" SIZE="50"></TD>
</TR>
<TR>
   <TD>$W_BCC: </TD>
   <TD><INPUT TYPE="text" NAME="bcc" SIZE="50"></TD>
</TR>
<TR>
   <TD>$W_REPLY_TO: </TD>
   <TD><INPUT TYPE="text" NAME="replyto" SIZE="50"></TD>
</TR>
<TR>
<TR>
   <TD>Attach File: </TD>
   <TD><INPUT TYPE="file" NAME="attachment" SIZE="40"></TD>
</TR>
<TR>
   <TD>$W_SUBJECT: </TD>
   <TD><INPUT TYPE="text" NAME="subject" SIZE="50"></TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND">
   </TD>
</TR>
<TR>
   <TD colspan=2>
<TEXTAREA NAME="mbody" cols="75" rows="14" wrap="HARD"></TEXTAREA><BR><BR>
   </TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND"></FORM>
   </TD>
</TR>
</TABLE>
!;
   &print_footer();
}

sub forwardmessage {
	my ($pop,$username,$encrypted_pass,$subject,$replyto,$from) = @_;
   &print_header();
	&print_lefttoolbar();
   print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0"
BGCOLOR="$BGCOLOR">
<TR>
   <TD colspan=2>
   <FONT COLOR="#FFFFFF" SIZE="2" face="Arial"><B>$READMESSAGE_FORWARD</B></FONT>
   </TD>
</TR>
<FORM ACTION="$CGIBINLOCATION" METHOD="POST" ENCTYPE="multipart/form-data">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
<INPUT TYPE="hidden" NAME="action" VALUE="sendmessage">
<TR>
   <TD valign=top align=left></TD>
   <TD valign=top align=left colspan=2><FONT COLOR="#FFFFFF" size=2 face="Arial">recipients seperated by (; or ,)</FONT></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_TO:</font> </TD>
   <TD><INPUT TYPE="text" NAME="to" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_CC:</font> </TD>
   <TD><INPUT TYPE="text" NAME="cc" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_BCC:</font> </TD>
   <TD><INPUT TYPE="text" NAME="bcc" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_REPLY_TO:</font> </TD>
   <TD><INPUT TYPE="text" NAME="replyto" VALUE="$$replyto" SIZE="50"></TD>
</TR>
<TR>
<TR>
   <TD><FONT size="2" face="Arial">Attach File:</font> </TD>
   <TD><INPUT TYPE="file" NAME="attachment" SIZE="40"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_SUBJECT:</font> </TD>
   <TD><INPUT TYPE="text" NAME="subject" VALUE="$$subject" SIZE="50"></TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND">
   </TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<TEXTAREA NAME="mbody" COLS="75" ROWS="14" WRAP="HARD">
!;
   $$from =~ s/^\s+//g;
   print STDOUT "\n\n";
   print STDOUT "$$from $W_WROTE:  \n\n";

	my $inbody = 2;
	my $attach = 0;
	my $boundry = '';
	foreach ($$pop->Head ($messnum)) {
		$attach = 1 if (/^Content-Type:\s+multipart/i);
		if(/boundary="(.*)"/i){
			$boundry = $1;
	   }
	}
   foreach ($$pop->Body ( $messnum )) {
		if (! $attach) {
		  $_ =~ s/<[^>]*>//gs;
		  print ">";
		  print "$_\n";
		  next;
		}
		if ($inbody){
		  if (/^--$boundry/ || /^$boundry/) {
		  		$inbody--;
				print ">[[Attachment Removed]]\n" if ! $inbody;
				next;
		  }
		  $_ =~ s/<[^>]*>//gs;
		  print ">";
		  print "$_\n";
		}
   }
   print STDOUT qq!
</TEXTAREA>
   </TD>
</TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND">
</FORM>
   </TD>
</TR>
</TABLE>
!;
   &print_footer();
}

sub listmessages {
	my ($pop,$username,$encrypted_pass,$lastdisplayed) = @_;
	my ($firstmessage,$lastmessage,$changecounter,$TDcolor);
	my $currenTDate = &get_date($datelanguage);

	&print_header();
	@messagesize=$$pop->ListArray();

	if ($NEWESTFIRST) {
		if($lastdisplayed){
			$firstmessage=($lastdisplayed - 1);
			if(($$pop->Count() - $lastdisplayed) > $MAXMESSLISTNUM){
				$lastmessage= ($$pop->Count() - $lastdisplayed);
			}else{
				$lastmessage=1;
			}
		}else{
			$firstmessage=$$pop->Count();
			if($$pop->Count() > $MAXMESSLISTNUM){
				$lastmessage= ($$pop->Count() - $MAXMESSLISTNUM);
			}else{
				$lastmessage=1;
			}
		}
		$changecounter=-1;
		if ($firstmessage>=$lastmessage) {
			$loop=1;
		} else {
			$loop=0;
		}
	} else {
		if($lastdisplayed){
			$firstmessage=($lastdisplayed + 1);
			if(($$pop->Count() - $lastdisplayed) > $MAXMESSLISTNUM){
				$lastmessage= ($$pop->Count() - $lastdisplayed);
			}else{
				$lastmessage=$$pop->Count();
			}
		}else{
			$firstmessage=1;
			if($$pop->Count() > $MAXMESSLISTNUM){
				$lastmessage= $MAXMESSLISTNUM;
			}else{
				$lastmessage=$$pop->Count();
			}
		}
		$changecounter=1;
		if ($firstmessage<=$lastmessage) {
			$loop=1;
		} else {
			$loop=0;
		}
	}

      print STDOUT qq!
<table bgcolor="$BGCOLOR" border=0 cellspacing="0" cellpadding="0" align="left" width="100%">
<tr>
<td colspan="1" align="left" valign="top">
	<table bgcolor="$BGCOLOR" border=0 cellspacing="2" cellpadding="2" valign="bottom" width="100%">
	<tr><td align="center">
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
   <INPUT TYPE="hidden" NAME="action" VALUE="createmessage">
   <INPUT TYPE="image" SRC="$IMAGELOCATION/compose.gif" ALT="$LISTMESSAGES_NEW" BORDER="0"><br><font face="Arial" size="2">
   $LISTMESSAGES_NEW</font>
   </FORM>
   </TD></TR>
<TR><TD align="center">
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
   <INPUT TYPE=hidden NAME="action" VALUE="listmessages">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
   <INPUT TYPE="image" SRC="$IMAGELOCATION/mailbox.gif" ALT="$LISTMESSAGES_REFRESH2" BORDER="0"><br>
   <font face="Arial" size="2">$LISTMESSAGES_REFRESH</font>
   </FORM>
   </TD></TR>
<TR><TD align="center">
   <FORM ACTION="$CGIBINLOCATION" METHOD="POST">
   <INPUT TYPE="hidden" NAME="action" VALUE="deleteallconfirm">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
   <INPUT TYPE="image" SRC="$IMAGELOCATION/trash.gif" ALT="$LISTMESSAGES_DELETE_ALL" BORDER="0"><br>
   <font face="Arial" size="2">$LISTMESSAGES_DELETE_ALL</font>
   </FORM>
   </TD></TR>
<TR><TD align="center">
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
   <INPUT TYPE="hidden" NAME="action" VALUE="logout">
   <INPUT TYPE="image" SRC="$IMAGELOCATION/logout.gif" ALT="$LISTMESSAGES_LOGOUT" BORDER="0"><br>
   <font face="Arial" size="2">$LISTMESSAGES_LOGOUT</font>
   </FORM>
   </TD></TR>
</TABLE>
</TD>

<td colspan="3" align="right">
<table bgcolor="#ffffff" border="0" cellspacing="2" cellpadding="2" align="center" width="100%">
<tr bgcolor="#ffffff">
<td colspan=5 bgcolor="$BGCOLOR" align="left"><font color="#ffffff" size="3" face="Arial">
[$currenTDate]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$LISTMESSAGES_CURRENT <b>$$username\@$HOSTNAME</b>

</font></td>
</tr>!;
if($$pop->Count() > $MAXMESSLISTNUM){
	my $message = "Displaying " . $firstmessage . "-" . $lastmessage . " of " . $$pop->Count();
	my $link = '';
	if(!$USE_COOKIES) {
		$link = "<a href=\"$CGIBINLOCATION?action=listmessages&lastdisplayed=$lastmessage&username=$$username&password=$$encrypted_pass\">$LISTMESSAGES_MORE</a>";
	}else{
		$link = "<a href=\"$CGIBINLOCATION?action=listmessages&lastdisplayed=$lastmessage\">$LISTMESSAGES_MORE</a>";
	}
	if( ($NEWESTFIRST && ($lastmessage <= 1)) || (!$NEWESTFIRST && ($lastmessage >= $$pop->Count() ) ) ){
		$link = '';
	}
	print STDOUT qq!
	<tr bgcolor="#ffffff"><td colspan=5 bgcolor="$BGCOLOR" align="left"><font color="#ffffff" size="3" face="Arial">
	$message &nbsp;&nbsp;&nbsp;&nbsp; $link</font></td></tr>!;
}
print STDOUT qq!
<tr bgcolor="#cccccc">
<td><font size="2" face="Arial"><b>$W_FROM</b></font></td>
<td><font size="2" face="Arial"><b>$W_SUBJECT</b></font></td>
<td><font size="2" face="Arial"><b>$W_DATE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b></font></td>
<td><font size="2" face="Arial"><b>$LISTMESSAGES_SIZE</b></font></td>
<td><font size="2" face="Arial"><b>$LISTMESSAGES_DELETE</b></font></td>
   <FORM ACTION="$CGIBINLOCATION" METHOD="POST">
   <INPUT TYPE="hidden" NAME="action" VALUE="deletemessage">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
</tr>

!;

	for ($i = $firstmessage; $loop; $i+=$changecounter) {

		if ($i % 2 != 0 ) {
			$TDcolor = "FFFFFF";
		} else {
			$TDcolor = "cccccc";
		}
		my $from = '';
		my $subject = '';
		my $dateofmess = '';
		foreach ($$pop->Head ( $i )) {
			$from = $_ if (/From:\s+/i);
			$subject = $_ if (/Subject:\s+/i);
			$dateofmess = $_ if (/Date:\s+/i);
			$dateofmess = substr($dateofmess, 0, 22);
			$sizeofmess = (int($messagesize[$i]/100)/10)."k";
		}
		if (!$subject) {
			$subject = "$LISTMESSAGES_NOSUBJECT";
		}else {
			$subject =~ s/Subject://i;
		}
		$from =~ s/From://i;
		$from =~ s/\"//g;
		$from =~ s/\</\(/g;
		$from =~ s/\>/\)/g;
		$from =~ s/X\-SMTP\-MAIL\-//g;
		$dateofmess =~ s/Date://i;
		if ($CONCISELISTING =~ (/[nN]/i)) {
			$from = "<B>$W_FROM:</B><BR> ".$from;
			$subject = "<B>$W_SUBJECT:</B><BR> ".$subject;
			$dateofmess = "<B>$LISTMESSAGES_ON:</B><BR> ".$dateofmess;
		} else {
			$from =~ s/\(.*\)//g;
		}

         print STDOUT qq!
<TR BGCOLOR="#$TDcolor">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
   		<TD><font size="2" face="Arial">
		<a href="$CGIBINLOCATION?username=$$username&password=$$encrypted_pass&action=readmessage&messnum=$i">
		$from</a></font></TD>!;
        }else{
                print STDOUT qq!
   		</TD>
   		<TD><font size="2" face="Arial">
		<a href="$CGIBINLOCATION?action=readmessage&messnum=$i">
		$from</a></font></TD>!;
	}
### old links between USE_COOKIES check
#<a href="$CGIBINLOCATION?username=$$username&password=$$encrypted_pass&action=deletemessage&delmessnum=$i">
#<img src="/images/delete.gif" border=0></a></font></TD>!;
print STDOUT qq!
   <TD><font size="2" face="Arial">$subject</font></TD>
   <TD><font size="2" face="Arial">$dateofmess</font></TD>
   <TD><font size="2" face="Arial">$sizeofmess</font></TD>
   <TD><font size="2" face="Arial">
   <input type="checkbox" name="delmessnum" value="$i"></input></font></TD>
</TR>
!;

		if ($NEWESTFIRST) {
			if ($i>$lastmessage) {
				$loop=1;
			} else {
				$loop=0;
			}
		} else {
			if ($i<$lastmessage) {
				$loop=1;
			} else {
				$loop=0;
			}
		}
	}
	print STDOUT qq!
	<tr bgcolor="#cccccc">
	<td><font size="2" face="Arial"><b>$W_FROM</b></font></td>
	<td><font size="2" face="Arial"><b>$W_SUBJECT</b></font></td>
	<td><font size="2" face="Arial"><b>$W_DATE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b></font></td>
	<td><font size="2" face="Arial"><b>$LISTMESSAGES_SIZE</b></font></td>
	<td><font size="2" face="Arial"><INPUT TYPE="image" SRC="$IMAGELOCATION/delete.gif" ALT="$LISTMESSAGES_DELETE" BORDER="0"></form></font></td>
	</tr>
       	</table>
	</td>
	<td></td>
	<td></td>
	</tr>
	!;
	&print_footer();
}

sub readmessage {
	my ($pop,$username,$encrypted_pass,$messnum) = @_;

      my $attach = 0;
      my $boundry = '';
      my $full_headers = '';
      &print_header();
      my $from = '';
      my $subject = '';
      my $to = '';
      my $cc = '';
      my $date = '';
      my $replyto = '';
      foreach ($$pop->Head ( $$messnum )) {
         $from = $_ if (/From:\s+/i);
         $subject = $_ if (/Subject:\s+/i);
         $to = $_ if (/^To:\s+/i);
         $cc = $_ if (/^CC:\s+/i);
         $replyto = $_ if (/Reply-To\?\s+/i);
         $date = $_ if (/Date:\s+/i);
		$attach = 1 if (/^Content-Type:\s+multipart/i);
		if(/boundary="(.*)"/i){
			$boundry = $1;
		}
		$full_headers .= "$_\n";
	}

      $subject =~ s/Subject://i;
      $from =~ s/(From:)|(\")|(\<)|(\>)|(\')//gi;
      $to =~ s/(To:)|(\")|(\<)|(\>)|(\')//gi;
      $cc =~ s/(CC:)|(\")|(\<)|(\>)|(\')//gi;

      if($to =~ / /){
      	$to =~ s/^ //;
      	if( my ($one,$two) = split(/ /,$to) ){
      		if( $one eq $two ){ $to = $one; }
      	}
      }

      if($cc =~ / /){
      	$cc =~ s/^ //;
      	if( my ($one,$two) = split(/ /,$cc) ){
      		if( $one eq $two ){ $cc = $one; }
      	}
      }

      if($from =~ / /){
      	$from =~ s/^ //;
      	if( my ($one,$two) = split(/ /,$from) ){
      		if( $one eq $two ){ $from = $one; }
      	}
      }

      $date =~ s/Date://i;
      $replyto =~ s/Reply-To://i if $replyto ne '';
      if($replyto eq ''){ $replyto = $from; }
      my $nextmessnum = $$messnum + 1;
      my $prevmessnum = $$messnum - 1;
		&print_lefttoolbar();
		&print_toptoolbar($pop,$username,$encrypted_pass,\$from, \$subject, \$date, \$replyto, \$to, \$nextmessnum, \$prevmessnum,$messnum,\$cc);

		if ($SHOW_HEADER) {
			print "$full_headers\n";
		   printf "======\nAttachments?: %s\nBoundry: %s\n======\n", 
				($attach ? 'Yes' : 'No' ), $boundry if $debug;
		}
		$boundry =~ s/\+//g;
		my $boundry_reached = 0;
		my $skip = 0;
		my $filename = '';
      foreach ($$pop->Body ( $$messnum )) {
			 # completely ignore the mess below if no attachment
			if (! $attach) { 
         			$cleanedtext=&CLEANHTML($_);
         			print "$cleanedtext<BR>";
			} else {
				# hopefully no one will notice ;-) mutt will use +es in
				# boundry names.  Others?
				if(/^--/) { $_ =~ s/\+//g; } 
				# OutHouseExpress sets the boundry in the header minus two
				# '-'es also Mutt does this but I don't believe Netscrape
				# does.
				if (/^$boundry/i || /^--$boundry/i) { 
					$boundry_reached++;
				   next;
				}
				if ($boundry_reached > 1) {
					if (! $skip) {
				 		print "BOUNDRY REACHED: $boundry\n" if $debug;
						print "</pre>\n";
						$skip = 1;
					} else {
						next if !/\s/;
						$filename = '';
						if (/\s+filename="*(.*)"*/i) { 
							# catch some dumb chars in filename not exaustive.
							# Spaces and Quotes just shouldn't be in filenames. 
							($filename = $1) =~ s/[\/"\\+'; ]//g;
# See comments in gettattachment re: $CGIBINLOCATION?$filename
							print STDOUT qq!
   ====== Attachment: $filename ======
   <FORM ACTION="$CGIBINLOCATION?$filename" METHOD="POST">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
   <INPUT TYPE="hidden" NAME="username" VALUE="$$username">
   <INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
   <INPUT TYPE="hidden" NAME="action" VALUE="getattachment">
   <INPUT TYPE="hidden" NAME="messnum" VALUE="$$messnum">
	<INPUT TYPE="hidden" NAME="filename" VALUE="$filename">
   <INPUT TYPE="submit" VALUE="Get: $filename">
   </FORM>
!;
							next;
						} # if filename
					next if $filename eq '';
					} # else boundry_reached > 1
				} # if boundry_reached >1
			 $cleanedtext=&CLEANHTML($_);
			 print "$cleanedtext<BR>";
      	} # else attached
		} # foreach pop->Body
		print STDOUT "</pre>\n" if ! $attach;
      print STDOUT qq!
   </TD>
</TR>
</TABLE>
<BR><BR>
!;
   &print_footer();
}

sub replymessage {
	my ($pop,$to,$subject,$messnum,$username,$encrypted_pass) = @_;
   $$to =~ s/([^\s\<]+\@[^\s\r\,\;\>]+)//g;
   $$to = $1;
   $$to =~ s/\(?\)?//g;
   &print_header();
	&print_lefttoolbar();
   print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0" 
BGCOLOR="$BGCOLOR">
<TR>
   <TD colspan=2><FONT COLOR=FFFFFF SIZE=2 face="Arial"><B>$READMESSAGE_REPLY $$to</B></FONT></TD>
</TR>
<FORM ACTION="$CGIBINLOCATION" METHOD="POST" ENCTYPE="multipart/form-data">
!;
	if(!$USE_COOKIES) {
		print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
	}
print STDOUT qq!
<TR>
   <TD valign=top align=left></TD>
   <TD valign=top align=left>
   <INPUT TYPE="hidden" NAME="action" VALUE="sendmessage">
   <FONT COLOR="#FFFFFF" size=2 face="Arial">recipients seperated by (; or ,)</FONT>
   </TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_TO:</font> </TD>
   <TD><INPUT TYPE="text" NAME="to" VALUE="$$to" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_CC:</font> </TD>
   <TD><INPUT TYPE="text" NAME="cc" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_BCC:</font> </TD>
   <TD><INPUT TYPE="text" NAME="bcc" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_REPLY_TO:</font> </TD>
   <TD><INPUT TYPE="text" NAME="replyto" SIZE="50"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">Attach File:</font> </TD>
   <TD><INPUT TYPE="file" NAME="attachment" SIZE="40"></TD>
</TR>
<TR>
   <TD><FONT size="2" face="Arial">$W_SUBJECT:</font> </TD>
   <TD><INPUT TYPE="text" NAME="subject" VALUE="$$subject" SIZE="50"></TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND">
   </TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<TEXTAREA NAME="mbody" COLS="75" ROWS="14" WRAP="HARD">
!;
   print "\n\n";
   print "$REPLYMESSAGE_YOU_WROTE:  \n\n";
	my $inbody = 2;
	my $attach = 0;
	my $boundry = '';
	foreach ($$pop->Head ($$messnum)) {
		$attach = 1 if (/^Content-Type:\s+multipart/i);
		if(/boundary="(.*)"/i){
			$boundry = $1;
	   }
	}
   foreach ($$pop->Body ( $$messnum )) {
		if (! $attach) {
		  $_ =~ s/<[^>]*>//gs;
		  print ">";
		  print "$_\n";
		  next;
		}
		if ($inbody){
		  if (/^--$boundry/ || /^$boundry/) {
		  		$inbody--;
				print ">[[Attachment Removed]]\n" if ! $inbody;
				next;
		  }
		  $_ =~ s/<[^>]*>//gs;
		  print ">";
		  print "$_\n";
		}
   }
   print STDOUT qq!
</TEXTAREA>
   </TD>
</TR>
<TR>
   <TD colspan=2 align=left>
<INPUT TYPE="submit" VALUE="$W_SEND"></FORM>
   </TD>
</TR>
</TABLE>
!;
   &print_footer();
}

sub sendmessage {
   my ($username,$to,$mbody,$replyto,$subject,$attachment,$cc,$bcc) = @_;
   chomp($$username,$$to,$$mbody,$$replyto,$$subject,$$attachment,$$cc,$$bcc);
   my $proto = getprotobyname('tcp');
   socket(SERVER, AF_INET, SOCK_STREAM, $proto);
   my $iaddr = gethostbyname($SMTPSERVER);
   my $port = getservbyname('smtp', 'tcp');
   my $sin = sockaddr_in($port, $iaddr);
   connect(SERVER, $sin) || &errno("$SENDMESSAGE_NOT_OPEN $SMTPSERVER");

   my @to;
   my @cc;
   my @bcc;

   ### split the to's
   if($$to =~ /\,/){
	@to = split /,/, $$to;
   }elsif($$to =~ /\;/){
   	@to = split /;/, $$to;
   }else{
	push @to, $$to;
   }

   ### split the cc's
   if($$cc =~ /\,/){
	@cc = split /,/, $$cc;
   }elsif($$cc =~ /\;/){
   	@cc = split /;/, $$cc;
   }else{
	push @cc, $$cc;
   }

   ### split the bcc's
   if($$bcc =~ /\,/){
	@bcc = split /,/, $$bcc;
   }elsif($$bcc =~ /\;/){
   	@bcc = split /;/, $$bcc;
   }else{
	push @bcc, $$bcc;
   }

   $$mbody =~ s/\n\.[\r|\n]/\n. $1/g;
   my $sreply;
   send SERVER, "HELO $HOSTNAME\r\n", 0;
   recv SERVER, $sreply, 512, 0;
   send SERVER, "MAIL From:$$username\@$HOSTNAME\r\n", 0;
   recv SERVER, $sreply, 512, 0;
   foreach $line (@to,@cc,@bcc) {
      send SERVER, "RCPT To:$line\r\n", 0;
   }
   recv SERVER, $sreply, 512, 0;
   send SERVER, "DATA\r\n", 0;

   foreach $line (@to) {
      send SERVER, "To: $line\r\n", 0;
   }

   foreach $line (@cc) {
      send SERVER, "Cc: $line\r\n", 0;
   }

   foreach $line (@bcc) {
      send SERVER, "Bcc: $line\r\n", 0;
   }

   recv SERVER, $sreply, 512, 0;
   send SERVER, "Reply-To: $$replyto\r\n", 0 if $$replyto && $$replyto ne '';
   send SERVER, "Subject: $$subject\r\n", 0;
   send SERVER, "X-Mailer: Jaos.org WebMail\r\n", 0; 

   if ($$attachment) {
    #my $type = $query->uploadInfo($$attachment)->{"Content-Type"};
    my $type = uploadInfo($$attachment)->{"Content-Type"};
    $atch_boundary = "-WEBMAIL-ATTACH-BOUNDARY-";
    @atch_filename = split(/\/|\\|:/, $$attachment);
    send SERVER, "MIME-Version: 1.0\r\n", 0;
    send SERVER, "Content-Type: multipart/mixed; ", 0;
    send SERVER, "boundary=\"$atch_boundary\"\r\n", 0;
    send SERVER, "\r\n--$atch_boundary\r\n", 0;
    send SERVER, "Content-type: text/plain\r\n\r\n", 0;
    send SERVER, "$$mbody\r\n", 0;
    send SERVER, "\r\n--$atch_boundary\r\n", 0;
    send SERVER, "Content-Type: $type; name=\"$atch_filename[-1]\"\r\n", 0;
    send SERVER, "Content-Transfer-Encoding: BASE64\r\n", 0;
    send SERVER, "Content-Description:\r\n\r\n", 0;
    while (<$$attachment>) { $atch_temp .= $_; }
    send SERVER, encode_base64($atch_temp), 0;
    send SERVER, "--$atch_boundary--", 0;
    send SERVER, "\r\n.\r\n", 0;
   } else {
   send SERVER, "\r\n$$mbody\r\n.\n", 0;
   }

   recv SERVER, $sreply, 512, 0;
   send SERVER, "QUIT\r\n", 0;
   recv SERVER, $sreply, 512, 0;
   close SERVER;
   return;
}

sub getattachment {
	my ($pop) = @_;
	my $attach = 0;
	my $boundry = '';
	my $full_headers = '';
      my $from = '';
      my $subject = '';
      foreach ($$pop->Head ( $messnum )) {
         $from = $_ if (/From:\s+/i);
         $subject = $_ if (/Subject:\s+/i);
			$attach = 1 if (/^Content-Type:\s+multipart/i);
			if(/boundary="(.*)"/i){
				$boundry = $1;
			}
			$full_headers .= "$_\n";
		}

      $subject =~ s/Subject://i;
      $from =~ s/From://i;
      $from =~ s/\"//gi;
      $from =~ s/\</\(/g;
      $from =~ s/\>/\)/g;
      my $nextmessnum = $messnum + 1;
      my $prevmessnum = $messnum - 1;
		$boundry =~ s/\+//g;
		my $boundry_reached = 0;
		my $skip = 0;
		my $filename = '';
		my $inbody = 0;
		my $encoded = '';
      foreach ($$pop->Body ( $messnum )) {
			 # hopefully no one will notice ;-) mutt will use +es in
			 # boundry names.  Others?
			 if(/^--/) { $_ =~ s/\+//g; } 
			 # OutHouseExpress sets the boundry in the header minus two
			 # '-'es also Mutt does this but I don't believe Netscrape
			 # does.
			 if (/^$boundry/i || /^--$boundry/i) { 
				 $boundry_reached++;
				 next;
			 }
			 if ($boundry_reached > 1) {
			 	if (! $skip ){
				  if(/^Content-Type:\s+(.*)$/i){
					  $content_type = $1;
					  $content_type =~ s/;//g;
				  }
				  if(/\s+filename="*(.*)"*/i) {
				  		($filename = $1) =~ s/[\/"\\+'; ]//g;
						if($file_name eq $filename){ 
							$skip = 1;
							$inbody = 0;
						}
				  }
			  } else { # ! skip
				  if (! $inbody) {
					  next if (/ / || /^$/ || /^\s+$/);
					  $inbody = 1;
				  }
				  if ( /^$/ || /^\s+$/) {
					  #$skip = 0;
					  $skip = 2;
					  next;
				  }
				  #$encoded .= "$_\n";
				  $encoded .= "$_\n" unless $skip == 2;
			  } 
			 } # boundry_reached
		  } # foreach pop->Body

	### lets push the file to the browser
	chomp $encoded;
	my $truefilename = (split /\?/,$filename)[1];
	my $sizeofattachment = length(&decode_base64($encoded));
	### amazingly this is worse than manually printing the headers.
	### it sets the filename first, so the length and type
	### headers become part of the file...
	#print header(-type=>'application/octet-stream',
		#-nph=>0,
		#-attachment=>$truefilename,
		#-Content_length=>$sizeofattachment);
	#print "\n\n";
	if($content_type =~ /text/){
		print STDOUT "Content-type: text/html\n";
	}else{
		print STDOUT "Content-type: application/octet-stream\n";
	}
	print STDOUT "Content-Length: $sizeofattachment\n";
	print STDOUT "Content-Disposition: attachment; filename=$truefilename\n\n";
	printf STDOUT "%s", &decode_base64($encoded);
	undef $encoded;
	return;
}

sub deleteall {
	my ($pop) = @_;
   for ($i = 1; $i <= $$pop->Count(); $i++) {
      $$pop->Delete ( $i);
   }
   return;
}

sub deleteallconfirm {
	my ($username,$encrypted_pass) = @_;
   &print_header();
   print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0"
BGCOLOR="$BGCOLOR">
<TR>
   <TD>
   <FONT COLOR="#FFFFFF" SIZE="4"><B>$LISTMESSAGES_DELETE_ALL</B></FONT>
   </TD>
</TR>
</TABLE>
<B>$DELETEMESSAGE_ALL_WARNING....</B>
<BR><BR>
$DELETEMESSAGE_ALL_MESSAGE<BR>
$DELETEMESSAGE_ALL_MESSAGE_QUESTION
<BR><BR>
<TABLE WIDTH="10%">
<TR>
   <TD>
   <FORM ACTION="$CGIBINLOCATION" METHOD="POST">
   <INPUT TYPE="hidden" NAME="action" VALUE="deleteall">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
        }
print STDOUT qq!
   <INPUT TYPE="submit" VALUE="$LISTMESSAGES_DELETE_ALL">
   </FORM>
   </TD>
   <TD>
   <FORM ACTION="$CGIBINLOCATION" METHOD="POST">
   <INPUT TYPE=hidden NAME="action" VALUE="listmessages">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$$encrypted_pass">!;
        }
print STDOUT qq!
   <INPUT TYPE="submit" VALUE="$DELETEMESSAGE_ALL_CANCEL">
   </FORM>
   </TD>
</TR>
</TABLE>
!;
   &print_footer();
}

sub deletemessage {
	my ($pop,$messnum) = @_;
      $$pop->Delete ( $messnum);
      return;
}

sub print_footer {
   print STDOUT qq!
</TABLE>
</BODY>
</HTML>
!;
}

sub print_header {

        my $cookie;
        ### Here we set the cookie if $USE_COOKIES is turned on
        if ($USE_COOKIES && $username && $encrypted_pass) {
                chomp($WEBSERVER);
                $cookie = cookie(
                        -name => "$WEBSERVER",
                        -nph => 1,
                        -value => "$username $encrypted_pass",
                        -domain => "$WEBSERVER",
                        -path => "$CGIBINLOCATION"
                );
                print STDOUT CGI::header(
                        -cache_control => 'private',
                        -type => 'text/html',
                        -cookie => $cookie
                );
        }else{
                print STDOUT CGI::header(
                        -cache_control => 'private',
                        -type => 'text/html'
                );
        }

   print STDOUT qq!
<HTML>
<HEAD><TITLE>$HOSTNAME - Webmail</TITLE></HEAD>
<BODY BGCOLOR="$BGCOLOR">
!;
}

sub print_lefttoolbar {
      print STDOUT qq!
<TABLE BGCOLOR="$BGCOLOR" border=0 cellspacing=0 cellpadding=0 WIDTH="100%">
<tr>
<td align=right valign=top>
<TABLE border=0 cellspacing=0 cellpadding=0 WIDTH="100%" BGCOLOR="$BGCOLOR">
<TR><TD align=center>
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$encrypted_pass">!;
        }
print STDOUT qq!
   <INPUT TYPE="hidden" NAME="action" VALUE="createmessage">
   <INPUT TYPE="image" SRC="$IMAGELOCATION/compose.gif" ALT="$LISTMESSAGES_NEW" BORDER="0"><br><font face="Arial" size="2">
   $LISTMESSAGES_NEW</font>
   </FORM>
   </TD></TR>
<TR><TD align=center>
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
   <INPUT TYPE=hidden NAME="action" VALUE="listmessages">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$username">  
<INPUT TYPE="hidden" NAME="password" VALUE="$encrypted_pass">!;
        }
print STDOUT qq!
   <INPUT TYPE="image" SRC="$IMAGELOCATION/mailbox.gif" ALT="$LISTMESSAGES_REFRESH2" BORDER="0"><br><font face="Arial" size="2">
   $LISTMESSAGES_REFRESH</font>
   </FORM>
   </TD></TR>
<TR><TD align=center>
   <FORM ACTION="$CGIBINLOCATION" METHOD="POST">
   <INPUT TYPE="hidden" NAME="action" VALUE="deleteallconfirm">
!;
        if(!$USE_COOKIES) {
                print STDOUT qq!
<INPUT TYPE="hidden" NAME="username" VALUE="$username">
<INPUT TYPE="hidden" NAME="password" VALUE="$encrypted_pass">!;
        }
print STDOUT qq!
   <INPUT TYPE="image" SRC="$IMAGELOCATION/trash.gif" ALT="$LISTMESSAGES_DELETE_ALL" BORDER="0"><br><font face="Arial" size="2">
   $LISTMESSAGES_DELETE_ALL</font>
   </FORM>
   </TD></TR>
<TR><TD align=center>
   <FORM ACTION="$CGIBINLOCATION" METHOD="post">
   <INPUT TYPE="hidden" NAME="action" VALUE="logout">
   <INPUT TYPE="image" SRC="$IMAGELOCATION/logout.gif" ALT="$LISTMESSAGES_LOGOUT" BORDER="0"><br><font face="Arial" size="2">
   $LISTMESSAGES_LOGOUT</font>
   </FORM>
   </TD></TR>
</TABLE>
</TD>
<TD valign=top align=right>
!;
}

sub print_toptoolbar {
	my ($pop,$username,$encrypted_pass,$from, $subject, $date, $replyto, $to, $nextmessnum, $prevmessnum,$messnum,$cc) = @_;
	my $replysubject = "Re: $$subject";
	my $forwardsubject = "Fwd: $$subject";
	print STDOUT qq!<TABLE WIDTH="100%" border=0 cellspacing=0 cellpadding=2><TR BGCOLOR="#cccccc"><TD align="left" colspan=2>!;
	if(!$USE_COOKIES) {

		print STDOUT qq!<a href="$CGIBINLOCATION?subject=$forwardsubject&action=forwardmessage&messnum=$$messnum&from=$$from&username=$$username&password=$$encrypted_pass"><font face="Arial" size="2">$READMESSAGE_FORWARD</font></a>!;
		print STDOUT qq! | !;
		print STDOUT qq!<a href="$CGIBINLOCATION?to=$$replyto&subject=$replysubject&action=replymessage&messnum=$$messnum&username=$$username&password=$$encrypted_pass"><font face="Arial" size="2">$READMESSAGE_REPLY</font></a>!;
		print STDOUT qq!</td><td align="center" colspan=2>!;
		print STDOUT qq!<a href="$CGIBINLOCATION?action=deletemessage&messnum=$$messnum&username=$$username&password=$$encrypted_pass">$LISTMESSAGES_DELETE_MESSAGE</a>!;
		print STDOUT qq!</td><td align="right" colspan=2>!;

		if ($$nextmessnum > $$pop->Count() ) {
			print STDOUT qq!<font face="Arial" size="2">$READMESSAGE_NEXT</font>!;
		}else{
			print STDOUT qq!<a href="$CGIBINLOCATION?action=readmessage&messnum=$$nextmessnum&username=$$username&password=$$encrypted_pass"><font face="Arial" size="2">$READMESSAGE_NEXT</font></a>!;
		}
		print STDOUT qq! | !;
		if ($$messnum == 1) {
			print STDOUT qq!<font face="Arial" size="2">$READMESSAGE_PREVIOUS</font>!;
		}else{
			print STDOUT qq!<a href="$CGIBINLOCATION?action=readmessage&messnum=$$prevmessnum&username=$$username&password=$$encrypted_pass"><font face="Arial" size="2">$READMESSAGE_PREVIOUS</font></a>!;
		}

	}else{

		print STDOUT qq!<a href="$CGIBINLOCATION?subject=$forwardsubject&action=forwardmessage&messnum=$$messnum&from=$$from"><font face="Arial" size="2">$READMESSAGE_FORWARD</font></a>!;
		print STDOUT qq! | !;
		print STDOUT qq!<a href="$CGIBINLOCATION?to=$$replyto&subject=$replysubject&action=replymessage&messnum=$$messnum"><font face="Arial" size="2">$READMESSAGE_REPLY</font></a>!;
		print STDOUT qq!</td><td align="center" colspan=2>!;
		print STDOUT qq!<a href="$CGIBINLOCATION?action=deletemessage&messnum=$$messnum">$LISTMESSAGES_DELETE_MESSAGE</a>!;
		print STDOUT qq!</td><td align="right" colspan=2>!;

		if ($$nextmessnum > $$pop->Count() ) {
			print STDOUT qq!<font face="Arial" size="2">$READMESSAGE_NEXT</font>!;
		}else{
			print STDOUT qq!<a href="$CGIBINLOCATION?action=readmessage&messnum=$$nextmessnum"><font face="Arial" size="2">$READMESSAGE_NEXT</font></a>!;
		}
		print STDOUT qq! | !;
		if ($$messnum == 1) {
			print STDOUT qq!<font face="Arial" size="2">$READMESSAGE_PREVIOUS</font>!;
		}else{
			print STDOUT qq!<a href="$CGIBINLOCATION?action=readmessage&messnum=$$prevmessnum"><font face="Arial" size="2">$READMESSAGE_PREVIOUS</font></a>!;
		}

	}

	print STDOUT qq!</td></TR>!;
	print STDOUT qq!<tr><td colspan=2></td><td colspan=1></td><td colspan=2></td></tr>!;
	print STDOUT qq!</TABLE><TABLE CELLSPACING="1" CELLPADDING="0" WIDTH="100%">!;
	print STDOUT qq!
<TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_SUBJECT:</B> $$subject</FONT></TD>
</TR>
<TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_DATE:</B> $$date</FONT></TD>
</TR>
<TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_FROM:</B> $$from</FONT></TD>
</TR>
!;
      if ($$to ne '') {
          print STDOUT qq!
   <TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_TO:</B> $$to</FONT></TD>
   </TR>
!
      }
      if ($$cc ne '') {
          print STDOUT qq!
   <TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_CC:</B> $$cc</FONT></TD>
   </TR>
!
      }
      if ($$replyto ne '') {
          print STDOUT qq!
   <TR BGCOLOR="#cccccc">
   <TD colspan="3"><FONT SIZE="2" face="Arial"><B>$W_REPLY_TO:</B> $$replyto</FONT></TD>
   </TR>
!
      }
print STDOUT qq!
</TR>
</TABLE>
<TABLE CELLSPACING="1" CELLPADDING="0" WIDTH="100%">
<TR BGCOLOR="#cccccc">
   <TD><hr>
<pre>
!;
}

sub decrypt_pass {
        return ($cipher_handle->decrypt_hex($_[0]));
}

sub encrypt_pass {
        return($cipher_handle->encrypt_hex($_[0]));
}

sub get_date {
        my ($lang) = @_;
        if (! defined $lang || $lang eq '') { $lang = 'english'; }
        my $tmpdate = localtime;
        my (@t) = split(/\s+/, $tmpdate);
        my (@h) = split(/:/, $t[3]);
        if($lang eq 'english') {
          my %month = (
          'Jan' => 'January',
          'Feb' => 'February',
          'Mar' => 'March',
          'Apr' => 'April',
          'May' => 'May',
          'Jun' => 'June',
          'Jul' => 'July',
          'Aug' => 'August',
          'Sep' => 'September',
          'Oct' => 'October',
          'Nov' => 'November',
          'Dec' => 'December'
                );
         my %day = (
                'Sun' => 'Sunday',
                'Mon' => 'Monday',
                'Tue' => 'Tuesday',
                'Wed' => 'Wednesday',
                'Thu' => 'Thursday',
                'Fri' => 'Friday',
                'Sat' => 'Saturday'
                 );
         #  format date same way as original backtick date did.
          return (sprintf "%s %s %s %s, %02d:%02d%s",
                $day{$t[0]}, $month{$t[1]}, $t[2], $t[4],
                        ($h[0] < 12 ? $h[0] : $h[0] - 12),
                        $h[1], ($h[0] < 12 ? 'AM' : 'PM'));
   } # if english
        # other languages I only speak english and computer languages :-)
}

sub CLEANHTML {
	my ($text) = @_;
        if ($SEMISPOTLESS) {
                return '' if $text =~ /^This is a multi-part/i;
                return '' if $text =~ /^Content-Type:/i;
                return '' if $text =~ /^Content-Transfer-Encoding/i;
                return '' if $text =~ /^------=_NextPart/;
                return '' if $text =~ /^\s+charset=/i;
                return '' if $text =~ /^\s+boundary="----=_NextPart/i;
        }

	$text =~ s/<(([^ >]|\n)*)>//g;
	### kindly borrowed from cvsweb =]
	$text =~ s/&/&amp;/g;
	$text =~ s/\"/&quot;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;

	# get URL's as link ..
	$text =~ s!(http|ftp)(://[-a-zA-Z0-9%.~:_/]+)([?&]([-a-zA-Z0-9%.~:_]+)=([-a-zA-Z0-9%.~:_])+)*!<A HREF="$1$2$3">$1$2$3</A>!g;
	# get e-mails as link
	if(!$USE_COOKIES){
		$text =~ s!([-a-zA-Z0-9_.]+@([-a-zA-Z0-9]+\.)+[A-Za-z]{2,4})!<A HREF="mailto:$1">$1</A> \[<A href="$CGIBINLOCATION?action=createmessage&username=$username&password=$encrypted_pass&to=$1">Email Now</a>\]!g;
	}else{
		$text =~ s!([-a-zA-Z0-9_.]+@([-a-zA-Z0-9]+\.)+[A-Za-z]{2,4})!<A HREF="mailto:$1">$1</A> \[<A href="$CGIBINLOCATION?action=createmessage&to=$1">Email Now</a>\]!g;
	}

	return $text; 
}

sub errno {
   my ($errmsg) = @_;
   &print_header();
   print STDOUT qq!
<TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="0" BORDER="0"
BGCOLOR="$BGCOLOR">
<TR>
   <TD>
   <FONT COLOR="#FFFFFF" SIZE="4"><B>$errmsg - $HOSTNAME WebMail
   Login</B></FONT>
   </TD>
</TR>
</TABLE>
<FONT SIZE="2">
$ERRNO_MESSAGE
<BR>
<FORM ACTION="$CGIBINLOCATION" METHOD=POST>
<INPUT TYPE=hidden NAME="action" VALUE="listmessages">
<B>$LOGIN_USERNAME: <BR></B><INPUT TYPE="text" NAME="username" VALUE="$username"><BR>
<B>$LOGIN_PASSWORD: <BR></B><INPUT TYPE="password" NAME="password"><BR>
<INPUT TYPE="submit" VALUE="login"><p></FORM><p>
!;
   &print_footer();
   exit 0;
}

### Code to use Net::SMTP
sub sendsmtp {
   my ($username,$to,$mbody,$replyto,$subject,$attachment,$cc,$bcc) = @_;
   chomp($$username,$$to,$$mbody,$$replyto,$$subject,$$attachment,$$cc,$$bcc);

   my @to;
   my @cc;
   my @bcc;

   ### split the to's
   if($$to =~ /\,/){
	@to = split /,/, $$to;
   }elsif($$to =~ /\;/){
   	@to = split /;/, $$to;
   }else{
	push @to, $$to;
   }

   ### split the cc's
   if($$cc =~ /\,/){
	@cc = split /,/, $$cc;
   }elsif($$cc =~ /\;/){
   	@cc = split /;/, $$cc;
   }else{
	push @cc, $$cc;
   }

   ### split the bcc's
   if($$bcc =~ /\,/){
	@bcc = split /,/, $$bcc;
   }elsif($$bcc =~ /\;/){
   	@bcc = split /;/, $$bcc;
   }else{
	push @bcc, $$bcc;
   }

   $$mbody =~ s/\n\.[\r|\n]/\n. $1/g;

	my $smtp=Net::SMTP->new("$SMTPSERVER",
			 Hello => "$WEBSERVER");
	$smtp->mail("$$username\@$HOSTNAME");
	foreach $line (@to,@cc,@bcc) {
		$smtp->to("$line");
	}

	$smtp->data;

	$smtp->datasend("From: $$username\@$HOSTNAME\r\n");

	foreach $line (@to) {
		$smtp->datasend("To: $line\r\n");
	}

	foreach $line (@cc) {
		$smtp->datasend("Cc: $line\r\n");
	}

	foreach $line (@bcc) {
		$smtp->datasend("Bcc: $line\r\n");
	}

	$smtp->datasend("Reply-To: $$replyto\r\n") if $$replyto && $$replyto ne '';
	$smtp->datasend("Subject: $$subject\r\n");
	$smtp->datasend("X-Mailer: Jaos.org WebMail\r\n");

	if ($$attachment) {
		#my $type = $query->uploadInfo($$attachment)->{"Content-Type"};
		my $type = uploadInfo($$attachment)->{"Content-Type"};
		$atch_boundary = "-WEBMAIL-ATTACH-BOUNDARY-";
		@atch_filename = split(/\/|\\|:/, $$attachment);
		$smtp->datasend("MIME-Version: 1.0\r\n");
		$smtp->datasend("Content-Type: multipart/mixed; ");
		$smtp->datasend("boundary=\"$atch_boundary\"\r\n");
		$smtp->datasend("\r\n--$atch_boundary\r\n");
		$smtp->datasend("Content-type: text/plain\r\n\r\n");
		$smtp->datasend("$$mbody\r\n");
		$smtp->datasend("\r\n--$atch_boundary\r\n");
		$smtp->datasend("Content-Type: $type; name=\"$atch_filename[-1]\"\r\n");
		$smtp->datasend("Content-Transfer-Encoding: BASE64\r\n");
		$smtp->datasend("Content-Description:\r\n\r\n");
		while (<$$attachment>) { $atch_temp .= $_; }
		$smtp->datasend(encode_base64($atch_temp));
		$smtp->datasend("--$atch_boundary--");
		$smtp->datasend("\r\n.\r\n");
	} else {
		$smtp->datasend("\r\n");
		$smtp->datasend("$$mbody");
		$smtp->datasend("\r\n");
   	}

	$smtp->dataend;
	return;
}
